//
//  WiFi.h
//  GodexWiFi
//
//  Created by SF639 on 2014/10/30.
//  Copyright (c) 2014年 GODEX. All rights reserved.
//
// 2015/2/10    新增可顯示目前版本資料的字串
// 2015/3/6     更改openPort為open，新增port可讓使用者輸入
// 2015/4/16    ver 2.0 新增scan local printer的功能

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

//20150108 新增列舉項目，為印表機列印模式
enum {
    GapLabel = 0,
    PlainPaper = 1,
    BlackMarkLabel = 2
};

typedef struct ARGBPixel {
    unsigned char a;
    unsigned char r;
    unsigned char g;
    unsigned char b;
} ARGBPixel;

typedef struct RGBPixel {
    unsigned char r;
    unsigned char g;
    unsigned char b;
} RGBPixel;

#define BITS_PER_COMPONENT 8
#define _32_BYTE_PER_PIXEL 4
#define _24_BYTE_PER_PIXEL 3

@interface GoDEXWiFi : NSObject <NSStreamDelegate>

@property(nonatomic, strong) NSString *version;

- (BOOL)open:(NSString *)address port:(NSInteger)port;
- (BOOL)open:(NSString *)address port:(NSInteger)port timeout:(NSInteger)timeout;
- (void)close;
- (BOOL)sendCommand:(NSString *)command;
- (BOOL)sendCommand:(NSString *)command encoding:(NSInteger)encode;
- (NSString *)read;
- (NSString *)read:(NSInteger)timeout;

- (NSArray *)findAllNet;

- (BOOL)setup:(NSInteger)height
          gap:(NSInteger)gap
          top:(NSInteger)top
         dark:(NSInteger)dark
        speed:(NSInteger)speed
         mode:(NSInteger)mode;

//mode of GapLabel
//- (BOOL)setup:(NSInteger)height
//          gap:(NSInteger)gap
//         dark:(NSInteger)dark
//        speed:(NSInteger)speed;

//mode of PlainPaper
//- (BOOL)setup:(NSInteger)height
//          top:(NSInteger)top
//         dark:(NSInteger)dark
//        speed:(NSInteger)speed;

//mode of BlackMarkLabel
//- (BOOL)setup:(NSInteger)height
//          gap:(NSInteger)gap
//          top:(NSInteger)top
//         dark:(NSInteger)dark
//        speed:(NSInteger)speed;

- (BOOL)printCmdFile:(NSString *)fileName;
- (BOOL)loadImage:(NSString *)fileName imageID:(NSString *)imageID;
- (BOOL)putImage:(UIImage *)image
          pointX:(NSInteger)px
          pointY:(NSInteger)py;
@end
