//
//  ViewController.m
//  testView
//
//  Created by SF639 on 2015/3/6.
//  Copyright (c) 2015年 GoDEX. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
@property (strong, nonatomic) IBOutlet UITextField  *ip;
@property (strong, nonatomic) IBOutlet UITextField  *command;
@property (strong, nonatomic) IBOutlet UITextView   *message;
@property (strong, nonatomic) IBOutlet UIImageView  *label;
@property (nonatomic) NSInteger flag;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    UIImage *image = [UIImage imageNamed:@"RT700i.bmp"];
    _label.image = image;
    
    _ip.placeholder = @"input printer IP address";    //eg. 192.168.102.100
    _ip.delegate = self;
    
    _command.placeholder = @"command";
    _command.delegate = self;
    
    _message.text = @"";
    _message.editable = NO;
    
    _flag = 0;
    
    _godex = [[GoDEXWiFi alloc] init];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    if (![_ip isExclusiveTouch]) {
        [_ip resignFirstResponder];
    }
    
    if (![_command isExclusiveTouch]) {
        [_command resignFirstResponder];
    }
}

- (IBAction)connect:(id)sender
{
    NSString *string = [[NSString alloc] init];
    
    if (_flag == 0) {
        if ([_godex open:_ip.text port:9100]) {
            string = @"連線成功";
            _flag = 1;
        } else {
            string = @"連線失敗";
        }
    } else {
        string = @"連線中";
    }
    
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                    message:string
                                                   delegate:self
                                          cancelButtonTitle:@"確定"
                                          otherButtonTitles:nil, nil];
    [alert show];
}

- (IBAction)disconnect:(id)sender
{
    NSString *string = [[NSString alloc] init];

    if (_flag == 1) {
        [_godex close];
        string = @"連線中斷";
        _flag = 0;
    } else {
        string = @"尚未連線";
    }
    
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                    message:string
                                                   delegate:self
                                          cancelButtonTitle:@"確定"
                                          otherButtonTitles:nil, nil];
    [alert show];
}

- (IBAction)sendAndRead:(id)sender
{
    if (_flag == 1) {
        if ([_godex sendCommand:_command.text]) {
            _message.text = [_message.text stringByAppendingString:[_godex read]];
            _message.text = [_message.text stringByAppendingString:@"\n"];
        } else {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                            message:@"傳輸資料發生錯誤"
                                                           delegate:self
                                                  cancelButtonTitle:@"確定"
                                                  otherButtonTitles:nil, nil];
            [alert show];
        }
    } else {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                        message:@"尚未連線"
                                                       delegate:self
                                              cancelButtonTitle:@"確定"
                                              otherButtonTitles:nil, nil];
        [alert show];
    }
}

- (IBAction)printCmdFile:(id)sender
{
    if (self.flag == 1) {
        NSString *path = [[NSBundle mainBundle] pathForResource:@"testFile" ofType:@"txt"];
        if (![_godex printCmdFile:path]) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                            message:@"傳輸資料發生錯誤"
                                                           delegate:self
                                                  cancelButtonTitle:@"確定"
                                                  otherButtonTitles:nil, nil];
            [alert show];
        }
    } else {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                        message:@"尚未連線"
                                                       delegate:self
                                              cancelButtonTitle:@"確定"
                                              otherButtonTitles:nil, nil];
        [alert show];
    }
}

- (IBAction)loadImage:(id)sender
{
    if (self.flag == 1) {
        NSString *path = [[NSBundle mainBundle] pathForResource:@"RT700i" ofType:@"bmp"];
        
        [_godex setup:40 gap:2 top:0 dark:10 speed:2 mode:1];
        [_godex sendCommand:@"^P1"];
        [_godex sendCommand:@"~MDELG,image1"];
        [_godex loadImage:path imageID:@"image1"];
        [_godex sendCommand:@"^L"];
        [_godex sendCommand:@"Y0,0,image1"];
        [_godex sendCommand:@"E"];
    } else {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@""
                                                        message:@"尚未連線"
                                                       delegate:self
                                              cancelButtonTitle:@"確定"
                                              otherButtonTitles:nil, nil];
        [alert show];
    }
}

@end
