//
//  ViewController.swift
//  testView_by_swift
//
//  Created by SF639 on 2015/3/12.
//  Copyright (c) 2015年 GoDEX. All rights reserved.
//

import UIKit

class ViewController: UIViewController, UITextFieldDelegate, UITextViewDelegate{
    @IBOutlet var ip: UITextField!
    @IBOutlet var command: UITextField!
    @IBOutlet var message: UITextView!
    @IBOutlet var label: UIImageView!
    var flag = 0
    var godex = GoDEXWiFi()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        var image = UIImage(named: "RT700i.bmp")
        label.image = image
        
        ip.placeholder = "input printer IP address";    //eg. 192.168.102.100
        ip.delegate = self
        
        message.text = ""
        message.editable = false
        
        command.placeholder = "command"
        command.delegate = self
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override func touchesEnded(touches: Set<NSObject>, withEvent event: UIEvent)
    {
        if !ip.exclusiveTouch {
            ip.resignFirstResponder()
        }
        
        if !command.exclusiveTouch {
            command.resignFirstResponder()
        }
    }

    @IBAction func connect(sender: AnyObject)
    {
        var string = NSString()
        
        if flag == 0 {
            if godex.open(ip.text, port: 9100) {
                string = "連線成功"
                flag = 1
            } else {
                string = "連線失敗"
            }
        } else {
            string = "連線中"
        }
        
        var alert = UIAlertView(title: "", message: string as String, delegate: self, cancelButtonTitle: "確定")
        alert.show()
    }

    @IBAction func disconnect(sender: AnyObject)
    {
        var string = NSString()
        
        if flag == 1 {
            godex.close()
            string = "連線中斷"
            flag = 0
        } else {
            string = "未連線"
        }
        
        var alert = UIAlertView(title: "", message: string as String, delegate: self, cancelButtonTitle: "確定")
        alert.show()
    }
    
    @IBAction func sendAndRead(sender: AnyObject)
    {
        if flag == 1 {
            if godex.sendCommand(command.text) {
                message.text = message.text.stringByAppendingString(godex.read())
            } else {
                var alert = UIAlertView(title: "", message: "傳輸資料發生錯誤", delegate: self, cancelButtonTitle: "確定")
                alert.show()
            }
        } else {
            var alert = UIAlertView(title: "", message: "尚未連線", delegate: self, cancelButtonTitle: "確定")
            alert.show()
        }
    }
    
    @IBAction func printCmdFile(sender: AnyObject)
    {
        if flag == 1 {
            var path = NSBundle.mainBundle().pathForResource("testFile", ofType: "txt")
            if godex.printCmdFile(path) {
            } else {
                var alert = UIAlertView(title: "", message: "傳輸資料發生錯誤", delegate: self, cancelButtonTitle: "確定")
                alert.show()
            }
        } else {
            var alert = UIAlertView(title: "", message: "尚未連線", delegate: self, cancelButtonTitle: "確定")
            alert.show()
        }
    }
    
    @IBAction func loadImage(sender: AnyObject)
    {
        if flag == 1 {
            var path = NSBundle.mainBundle().pathForResource("RT700i", ofType: "bmp")
            
            godex.setup(40, gap: 2, top: 0, dark: 10, speed: 2, mode: 1)
            godex.sendCommand("^P1")
            godex.sendCommand("~MDELG,image1")
            godex.loadImage(path, imageID: "image1")
            godex.sendCommand("^L")
            godex.sendCommand("Y0,0,image1")
            godex.sendCommand("E")
        } else {
            var alert = UIAlertView(title: "", message: "尚未連線", delegate: self, cancelButtonTitle: "確定")
            alert.show()
        }
    }
}

